//+------------------------------------------------------------------+
//|                                                      STIX_v1.mq4 |
//|                           Copyright  2006, TrendLaboratory Ltd. |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                       E-mail: igorad2004@list.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, TrendLaboratory Ltd."
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_separate_window
#property indicator_buffers   2
#property indicator_color1    DarkTurquoise
#property indicator_width1    1 
#property indicator_color2    Red
#property indicator_width2    1
#property indicator_style2    2
#property indicator_level1    50
#property indicator_maximum   100
#property indicator_minimum   0

//
//
//
//
//

extern string TimeFrame       = "current time frame";
extern int    Length          = 10; // Period of evaluation
extern int    Smooth          = 5;  // Period of smoothing
extern int    ModeMA          = 1;  // Mode of Moving Average
extern bool   Interpolate     = true;

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsNotify    = false;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;

//
//
//
//
//

double STIX[];
double AvgSTIX[];
double trend[];

int    timeFrame;
string indicatorFileName;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,STIX);    SetIndexLabel(0,"STIX");
   SetIndexBuffer(1,AvgSTIX); SetIndexLabel(1,"AvgSTIX");
   SetIndexBuffer(2,trend);
   
      //
      //
      //
      //
      //
      
        indicatorFileName = WindowExpertName();
        calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
        returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
        timeFrame         = stringToTimeFrame(TimeFrame);
        
      //
      //
      //
      //
      //
            
   IndicatorShortName(timeFrameToString(timeFrame)+"  Stix("+Length+","+Smooth+","+ModeMA+")");
return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { STIX[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
     for (i=limit; i>=0; i--)
     { 
        double bull = 0;
        double bear = 0;   
        for (int j=0;j<=Length-1;j++)
        {
           if(Close[i+j]>Close[i+j+1]) bull += 1;
           if(Close[i+j]<Close[i+j+1]) bear += 1;
        }
        if(bull+bear != 0) STIX[i] = 100*bull/(bull+bear);
     }
     for (i=limit; i>=0; i--)
     {
        AvgSTIX[i] = iMAOnArray(STIX,0,Smooth,0,ModeMA,i);     
        trend[i]   = trend[i+1];
           if (STIX[i]>AvgSTIX[i]) trend[i] =  1;
           if (STIX[i]<AvgSTIX[i]) trend[i] = -1;
   }         
   manageAlerts(); 
   return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         STIX[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,Smooth,ModeMA,0,y);
         AvgSTIX[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,Smooth,ModeMA,1,y);
         trend[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,Smooth,ModeMA,2,y);
         
         //
         //
         //
         //
         //
         
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
               STIX[i+k]    = STIX[i]    + (STIX[i+n]    - STIX[i])   * k/n;
               AvgSTIX[i+k] = AvgSTIX[i] + (AvgSTIX[i+n] - AvgSTIX[i])* k/n;
            }
   }
   manageAlerts();
return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Stix changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Stix "),message);
          if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," Stix " +" "+message));
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

